%undefine __cmake_in_source_build
%undefine __cmake3_in_source_build

Name:				davix
Version:			0.8.5
Release:    4%{?dist}
Summary:			Toolkit for http based file management
License:			LGPLv2+
URL:				https://dmc-docs.web.cern.ch/dmc-docs/davix.html
Source0:			https://github.com/cern-fts/davix/releases/download/R_0_8_5/davix-0.8.5.tar.gz

BuildRequires:			gcc-c++
BuildRequires:			cmake3
BuildRequires:			git-core
BuildRequires:			curl-devel
BuildRequires:			libxml2-devel
BuildRequires:			openssl-devel
BuildRequires:			rapidjson-devel
BuildRequires:			zlib-devel
BuildRequires:			gsoap-devel
BuildRequires:			libuuid-devel
BuildRequires:			gtest-devel
BuildRequires:			doxygen
BuildRequires:			python3-sphinx
BuildRequires:			python3-sphinx_rtd_theme

Requires:			%{name}-libs = %{version}-%{release}

%description
Davix is a toolkit designed for file operations with http based protocols
(WebDav, Amazon S3, ...).

%package tests
Summary:			Test suite for %{name}
Requires:			%{name}-libs = %{version}-%{release}

%description tests
Test suite for %{name}. Davix is a toolkit designed for file operations
with http based protocols (WebDav, Amazon S3, ...).

%package libs
Summary:			Runtime libraries for %{name}
Provides:			bundled(libcurl) = 7.69.0

%description libs
Libraries for %{name}. Davix is a toolkit designed for file operations
with http based protocols (WebDav, Amazon S3, ...).

%package devel
Summary:			Development files for %{name}
Requires:			%{name}-libs = %{version}-%{release}

%description devel
Development files for %{name}. Davix is a toolkit designed for file operations
with http based protocols (WebDav, Amazon S3, ...).

%package doc
Summary:			Documentation for %{name}
BuildArch:			noarch

%description doc
Documentation and examples for %{name}. Davix is a toolkit designed 
for file operations with http based protocols (WebDav, Amazon S3, ...).

%prep
%autosetup -p1

rm -rf deps/googletest/googlemock
rm -rf deps/googletest/googletest/*
touch deps/googletest/googletest/CMakeLists.txt
rm -rf src/libs/rapidjson
rm -rf test/pywebdav
rm -rf doc/sphinx/_themes/sphinx_rtd_theme
ln -s /usr/include/rapidjson src/libs/rapidjson

%build
%cmake3 \
  -DDOC_INSTALL_DIR:PATH=%{_pkgdocdir} \
  -DENABLE_THIRD_PARTY_COPY:BOOL=TRUE \
  -DENABLE_HTML_DOCS:BOOL=TRUE
%cmake3_build
%cmake3_build --target doc
( cd %{_vpath_builddir}/doc ; \
  sphinx-build -q -b html ../../doc/sphinx build/html ; \
  rm -f build/html/.buildinfo ; \
  rm -rf build/html/.doctrees )

%check
%{_vpath_builddir}/test/unit/davix-unit-tests

%install
%cmake3_install
rm %{buildroot}%{_pkgdocdir}/LICENSE


%files
%{_bindir}/davix-cp
%{_bindir}/davix-get
%{_bindir}/davix-http
%{_bindir}/davix-ls
%{_bindir}/davix-mkdir
%{_bindir}/davix-put
%{_bindir}/davix-rm
%{_bindir}/davix-mv
%doc %{_mandir}/man1/davix-get.1*
%doc %{_mandir}/man1/davix-http.1*
%doc %{_mandir}/man1/davix-ls.1*
%doc %{_mandir}/man1/davix-mkdir.1*
%doc %{_mandir}/man1/davix-put.1*
%doc %{_mandir}/man1/davix-rm.1*
%doc %{_mandir}/man1/davix-mv.1*

%files tests
%{_bindir}/davix-tester
%{_bindir}/davix-unit-tests

%files libs
%{_libdir}/libdavix.so.*
%{_libdir}/libdavix_copy.so.*
%doc %{_pkgdocdir}/RELEASE-NOTES.md
%license LICENSE

%files devel
%{_includedir}/davix
%{_libdir}/libdavix.so
%{_libdir}/libdavix_copy.so
%{_libdir}/pkgconfig/davix.pc
%{_libdir}/pkgconfig/davix_copy.pc
%doc %{_mandir}/man3/libdavix.3*

%files doc
%doc %{_pkgdocdir}/html
%license LICENSE

%changelog
* Wed May 15 2024 Fanjun Kong <fanjunkong@tencent.com> - 0.8.5-4
- add git-core

* Tue May 07 2024 Fanjun Kong <fanjunkong@tencent.com> - 0.8.5-3
- epol debrand

* Mon May 06 2024 Fanjun Kong <fanjunkong@tencent.com> - 0.8.5-2
- debrand macros

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.8.5-1
- initial build
